using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Enemy : MonoBehaviour 
{
	public Atribute atribue = Atribute.ARMOURED;
	public float speed = 1.0f;
	public int health = 100;
	public float paymentAmount = 100.0f;
	public NavMeshAgent navMeshAgent = null;
	public GameObject enemyKilledExplosionParticles = null;
	public AudioClip enemyKilledSoundEffect = null;
	public GameObject enemyFireParicles = null;
	public float damageAmount = 0;
	float particleTimer = 0.0f;
	bool deathFXFired = false;
	//public List<Skills> skills = new List<Skills>();
	// Use this for initialization
	void Start () 
	{
		switch(atribue)
		{
		case Atribute.ARMOURED:
			navMeshAgent = gameObject.AddComponent<NavMeshAgent>();
			health = 1000;
			speed = 0.25f;
			break;
		
		case Atribute.SCOUT:
			navMeshAgent = gameObject.AddComponent<NavMeshAgent>();
			health = 200;
			speed = 0.75f;
			break;	
			
		case Atribute.LIGHT:
			navMeshAgent = gameObject.AddComponent<NavMeshAgent>();
			navMeshAgent.radius = 0.8f;
			health = 500;
			speed = 0.35f;
			break;
		}
		/*foreach(Skills skill in skills)
		{
			if(skill == Skills.STEALTH)
			{
				gameObject.AddComponent<Stealth>();
			}
		}*/
	}
	
	// Update is called once per frame
	void Update () 
	{
		Controller();
	}
	
	public void EnemyDestroy(bool killQuick)
	{
		if(!deathFXFired)
		{
			deathFXFired = true;
			GameController.explosionSoundQue = true;
			GameController.funds += paymentAmount;
			GameController.enemiesKilled++;
			Instantiate(enemyKilledExplosionParticles, gameObject.transform.position, Quaternion.identity);
		}
		if(killQuick)
			Destroy(gameObject);
		Destroy(gameObject, 0.2f);
	}
	
	void Controller()
	{
		navMeshAgent.speed = speed*10.0f;
		navMeshAgent.destination = GameObject.FindWithTag("goal").transform.position;
		if(health <= 0)
			EnemyDestroy(false);
		if(health <= 100)
		{
			particleTimer+= Time.deltaTime;
			if(particleTimer >= 0.25f)
			{
				Instantiate(enemyFireParicles, gameObject.transform.position, Quaternion.identity);
				particleTimer = 0.0f;
			}
		}
	
	}
}
