﻿using UnityEngine;
using System.Collections;

public class GUISystem : MonoBehaviour 
{
	public GameObject hoverInformation = null;
	GameObject menuTempDraw = null;
	//bool drawInfo = false;
	Vector3 drawPosition = Vector3.zero;
	Vector3 originalSize = Vector3.zero;
	Vector3 hoverSize = Vector3.zero;
	public int objectCode = 0;
	public bool needHoverInfo = true;
	public float worth;
	public static bool AoEtoggle = false;
	GameObject[] AoEArray;
	// Use this for initialization
	void Start () 
	{
		originalSize = gameObject.transform.localScale;
		drawPosition = gameObject.transform.position;
		drawPosition.z -= 2.2f;
		hoverSize = gameObject.transform.localScale;
		hoverSize.z += 0.05f;
		hoverSize.x += 0.05f; 
	}
	
	// Update is called once per frame
	void Update () 
	{
		AoEArray = GameObject.FindGameObjectsWithTag("AoE");
		if(PlacementManager.isPlaced == true)
		{
			if(objectCode == 0)
				Debug.Log("Please set an object code for: " + gameObject.name);
		}
	}
	
	void OnMouseEnter()
	{
		if(needHoverInfo && PlacementManager.isPlaced == true)
		{
			menuTempDraw = Instantiate(hoverInformation, drawPosition, Quaternion.Euler(0,180,0)) as GameObject;
			gameObject.transform.localScale = hoverSize;
		}
		if(objectCode < 0)
		{
			gameObject.transform.localScale = hoverSize;
		}
	}
	void OnMouseExit()
	{
		if(needHoverInfo)
			Destroy(menuTempDraw);
		gameObject.transform.localScale = originalSize;
	}
	void OnMouseDown()
	{
		if(PlacementManager.isPlaced == true && objectCode != -4)
			GameObject.FindWithTag("MainCamera").GetComponent<PlacementManager>().ObjectToHover(objectCode);
		if(objectCode == -1) //Start wave execute
		{
			gameObject.transform.localScale = originalSize;
			GameObject.FindWithTag("GM").GetComponent<GameController>().CycleWaveIndex();
			GameObject.FindWithTag("GM").GetComponent<GameController>().isBuildMode = false;
		}
		if(objectCode == -3)
		{
			Application.Quit();
		}
		if(objectCode == -4)
		{
			Application.LoadLevel(1);
		}
		AOEToggle(objectCode);
		
	}
	
	void AOEToggle(int aoeObjectCode)
	{
		if(aoeObjectCode == -2)
		{
			
			foreach(GameObject aoe in AoEArray)
			{
				if(AoEtoggle == false)
				{
					aoe.renderer.material.color = new Color (aoe.renderer.material.color.r,aoe.renderer.material.color.g,aoe.renderer.material.color.b,0);
				}
				else
				{
					aoe.renderer.material.color = new Color(aoe.renderer.material.color.r,aoe.renderer.material.color.g,aoe.renderer.material.color.b,0.498f);
				}
				
			}
			if(AoEtoggle == false)
				AoEtoggle = true;
			else
				AoEtoggle = false;
			gameObject.transform.localScale = originalSize;
		}
	}
	
}


/*Object codes for standard objects:
1 = Turret
2 = Super Turret
3 = Gaurd Tower
4 = Anti-Tank Mine
-4 = Start Game button
-3 = Quit button
-2 = AOE Toggle
-1 = GO button*/