﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class GameController : MonoBehaviour 
{
	public bool isBuildMode = true;
	//GameObject spawner = null;
	public int stage = 1;
	public static bool missileSoundQue = false;
	public static bool turretPrjSoundQue = false;
	public static bool explosionSoundQue = false;
	public static float funds = 500.0f;
	public static float baseHealth = 100.0f;
	public static bool gameOver = false;
	public static int enemiesKilled = 0;
	public static int waveCounter = 0;
	float buildTimer = 0.0f;
	//Object References
	GameObject[] GUIObjects;
	GameObject[] currentEnemyCount;
	public GameObject GUIBackDrop = null;
	public GameObject[] enemies = new GameObject[1];
	public GameObject fundsGameObjectGUI = null;
	public GameObject baseHealthGameObjectGUI = null;
	public GameObject waveGameObjectGUI = null;
	public AudioClip missleExplodeSound = null;
	public AudioClip turretPrjSound = null;
	public AudioClip explosionSound = null;
	public GameObject gameOverCard = null;
	
	//Object Resizings
	Vector3 guiResize = new Vector3(0.2f,1.0f,1.0f);
	GameObject guiBacking = null;
	
	//Lecture Section
	//public Wave wave = null;
	public List<Wave> wave = new List<Wave>();
	public static int currentWaveIndex = 0;
	//End Lecture Section


	// Use this for initialization
	void Start () 
	{
		guiBacking = GameObject.FindGameObjectWithTag("static_GUI");
		//spawner = GameObject.FindGameObjectWithTag("spawner");
		GUIObjects = GameObject.FindGameObjectsWithTag("GUI");
		//lecture
		//foreach(WaveElement waveElement in wave[currentWaveIndex].waveElements)
		//{
		//	StartCoroutine(SpawnEnemy(waveElement.enemyType, waveElement.releaseTime));
		//}
		
		//end lecture
	}
	
	// Update is called once per frame
	void Update () 
	{
		GUIController();
		SoundController();
		WaveCheck();
		if(!isBuildMode)
			buildTimer += Time.deltaTime;
		if(baseHealth <= 0)
			GameOver();
		if(currentWaveIndex >= 17)
			currentWaveIndex = 0;
	}
	
	
	
	//lecture
	public IEnumerator SpawnEnemy(GameObject prefab, float delay)
	{
		yield return new WaitForSeconds(delay);
		Instantiate(prefab, GameObject.FindGameObjectWithTag("spawner").transform.position, Quaternion.identity);
	}
	//end lecture
	
	void SoundController()
	{
		if(turretPrjSoundQue == true)  //The missle is destroyed before it can finish it's sound effect, therefore, the gamecontroller helps out.
		{
			audio.PlayOneShot(turretPrjSound);
			turretPrjSoundQue = false;
		}
		
		if(missileSoundQue == true)  
		{
			audio.PlayOneShot(missleExplodeSound);
			missileSoundQue = false;
		}
		if(explosionSoundQue == true) 
		{
			audio.PlayOneShot(explosionSound);
			explosionSoundQue = false;
		}
	}
	
	void GUIController()
	{
		if(!isBuildMode || gameOver) //If it is not building mode, or the game is over, hide the GUI
		{
			foreach(GameObject guiRenderer in GUIObjects)
			{
				guiRenderer.SetActive(false);
			}
			guiBacking.transform.localScale = guiResize;
		}
		else
		{
			foreach(GameObject guiRenderer in GUIObjects)
			{
				guiRenderer.SetActive(true);
			}
			guiBacking.transform.localScale = new Vector3(1,1,1);
		}
		
		
		fundsGameObjectGUI.GetComponent<TextMesh>().text = "Funds: $" + funds.ToString() + ".00";
		baseHealthGameObjectGUI.GetComponent<TextMesh>().text = "Base Health: " + baseHealth.ToString() + "%";
		waveGameObjectGUI.GetComponent<TextMesh>().text = "Wave: " + (waveCounter).ToString();
	}
	void WaveCheck()
	{
		currentEnemyCount = GameObject.FindGameObjectsWithTag("enemy");
		if(currentEnemyCount.Length == 0 && buildTimer >= 2.0f && isBuildMode == false)
		{
			isBuildMode = true;
			buildTimer = 0.0f;
		}
	}
	public void CycleWaveIndex()
	{
		foreach(WaveElement waveElement in wave[currentWaveIndex].waveElements)
		{
			StartCoroutine(SpawnEnemy(waveElement.enemyType, waveElement.releaseTime));
		}
		currentWaveIndex++;
		waveCounter++;
	}
	void GameOver()
	{
		if(!gameOver)
		{
			GameObject[] enemiesLeft;
			
			enemiesLeft = GameObject.FindGameObjectsWithTag("enemy");
			gameOverCard.SetActive(true);
			foreach(GameObject enemy in enemiesLeft)
			{
				enemy.GetComponent<Enemy>().EnemyDestroy(false);
			}
			baseHealth = 0;
		}
		
		gameOver = true;
		
	}

}


























