﻿using UnityEngine;
using System.Collections;

public class PlacementManager : MonoBehaviour 
{

	public GameObject[] playerObjects = new GameObject[4];
	public static bool isPlaced = true;
	GameObject tempObject = null;
	Vector3 mousePosition = Vector3.zero;
	Vector3 modifiedMouseLocation = Vector3.zero;
	public AudioClip notEnoughFundsSound = null;
	bool testForPath = false;
	int tempObjectCode = 0;
	Collider tempCollider = null;
	public Material canNotPlaceMaterial = null;
	public Material originaMaterial;
	GameObject tempMaterial;
	public int spawnCount = 0;
	// Use this for initialization
	void Start () 
	{
	
	}
	
	// Update is called once per frame
	void Update () 
	{
		RaycastHit hit;
		Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
		if(Physics.Raycast(ray, out hit))
		{
			if(hit.collider != null)
				mousePosition = hit.point;
			if(hit.collider.gameObject.tag == "path")
				testForPath = true;
			else
				testForPath = false;
				
		}
		modifiedMouseLocation.x = mousePosition.x;
		modifiedMouseLocation.z = mousePosition.z;
		if(Input.GetMouseButtonDown(1))
		{
			if(!testForPath && tempObjectCode != 4)
			{
				Screen.showCursor = true;
				isPlaced = true;
				tempObjectCode = 0;
				tempCollider = tempObject.GetComponentInChildren<Collider>();
				tempCollider.enabled = true;
			}
			else if(tempObjectCode == 4)
			{
				tempCollider = tempObject.GetComponentInChildren<Collider>();
				tempCollider.enabled = true;
				isPlaced = true;
				Screen.showCursor = true;
			}
			else
			{
				audio.PlayOneShot(notEnoughFundsSound);
			}
		}
		
		if(!isPlaced)
		{	
			tempObject.transform.position = modifiedMouseLocation;
			tempCollider = tempObject.GetComponentInChildren<Collider>();
			tempCollider.enabled = false;
			Screen.showCursor = false;
			
			if(tempObjectCode != 4)
			{
				tempMaterial = GameObject.Find(tempObject.name + "/AoE");
				if(!testForPath)
					tempMaterial.renderer.material = originaMaterial;
				else
					tempMaterial.renderer.material = canNotPlaceMaterial;
			}
		}
		
		
		
	}
	
	public void ObjectToHover(int objectCode)
	{
		float price = 0.0f;
		if(objectCode >= 1)
		{
				switch(objectCode)
				{
				case 1:
					 price = GameObject.Find("Turret_Item_Cost").GetComponent<ItemPriceCompare>().cost;
					 tempObjectCode = 1;
					break;
				case 2:
					 price = GameObject.Find("SuperTurretItem_Cost").GetComponent<ItemPriceCompare>().cost;
					tempObjectCode = 2;
					break;
				case 3:
					 price = GameObject.Find("GT_Item_Cost").GetComponent<ItemPriceCompare>().cost;
					tempObjectCode = 3;
					break;
				case 4:
					 price = GameObject.Find("ATMine_Item_Cost").GetComponent<ItemPriceCompare>().cost;
					tempObjectCode = 4;
					break;
				default:
					Debug.Log("Error! PlacementManager.cs was looking for a cost to subtract from GameController but it didn't get passed a valid item code!");
					break;	
				}
				if(price <= GameController.funds && isPlaced == true)
				{
					tempObject = Instantiate(playerObjects[objectCode-1], Vector3.zero, Quaternion.identity) as GameObject;
					spawnCount++;
					tempObject.name = tempObject.name + spawnCount.ToString();
					GameController.funds -= price;
					isPlaced = false;
				}
				else
					audio.PlayOneShot(notEnoughFundsSound);
			}
		
	}
}
