﻿using UnityEngine;
using System.Collections;

public class Projectile : MonoBehaviour 
{
	public GameObject[] findTargets;
	GameObject closestTarget = null;
	public GameObject target = null;
	public float speed = 10.0f;
	public GameObject explosionParticles = null;
	bool calledDestroy = false;
	// Update is called once per frame
	void Update () 
	{
		findTargets = GameObject.FindGameObjectsWithTag("enemy");
		
		if(findTargets.Length == 0 && calledDestroy == false)
		{
			calledDestroy = true;
			target = null;
			OnMissileDestroy();
		}
		else if(target == null)
		{
			foreach(GameObject missile in findTargets) //Locate closest target and set as target
			{
				if(closestTarget == null)
					closestTarget = missile;
				else if(Vector3.Distance(gameObject.transform.position, missile.transform.position) < Vector3.Distance(gameObject.transform.position, closestTarget.transform.position))
					closestTarget = missile;
			}
			target = closestTarget;
		}
		if(target != null)
		{
			gameObject.transform.LookAt(target.transform.position);
			gameObject.transform.position = Vector3.MoveTowards(gameObject.transform.position, target.transform.position, speed*Time.deltaTime);
		}
	}
	
	void OnTriggerEnter(Collider other)
	{
		if(other.gameObject.tag == "enemy" && calledDestroy == false)
		{
			calledDestroy = true;
			other.GetComponent<Enemy>().health -= 100;
			OnMissileDestroy();
		}
		if(other.gameObject.tag == "terrain")
			OnMissileDestroy();
	}
	
	public void OnMissileDestroy()
	{
		
		GameController.missileSoundQue = true;
		Instantiate(explosionParticles, gameObject.transform.position, Quaternion.identity);
		audio.Stop();
		Destroy(gameObject);
	}
	
}
