using UnityEngine;
using System.Collections;

public class Tower : MonoBehaviour 
{
	public bool attack = false;
	public float rateOfFire = 3.0f; //In Seconds
	public float fireTimer = 2.0f;
	public GameObject missile = null;
	GameObject[] targetsAvailable;
	public int lifespan = 0;
	bool deathFX = false;
	int roundWhenPlaced = 0;
	float smokeFXTimer = 0.0f;
	public GameObject explosionParticles = null;
	public GameObject smokeParticles = null;
	// Use this for initialization
	void Start () 
	{
		roundWhenPlaced = GameController.waveCounter;
	}
	
	// Update is called once per frame
	void Update () 
	{
		if(roundWhenPlaced+lifespan == GameController.waveCounter)
			DestroySelf();
		if(roundWhenPlaced+lifespan-1 == GameController.waveCounter)
			Smoke();
		targetsAvailable = GameObject.FindGameObjectsWithTag("enemy"); //check to see if there is anything left to attack
		if(targetsAvailable.Length == 0)
		{
			attack = false;
		}
		
		if(attack && targetsAvailable.Length > 0)
		{
			fireTimer += Time.deltaTime;
			if(fireTimer >= rateOfFire)
			{
				fireTimer = 0.0f;
				Instantiate(missile, gameObject.transform.position, Quaternion.identity);
			}
		}
	}
	
	void OnTriggerStay(Collider other)
	{
		if(other.gameObject.tag == "enemy")
			attack = true;	
	}
	void OnTriggerExit(Collider other)
	{
		if(other.gameObject.tag == "missile")
		{
			other.GetComponent<Projectile>().OnMissileDestroy();
			attack = false;
		}
			
	}
	void DestroySelf()
	{
		if(!deathFX)
		{
			deathFX = true;
			Instantiate(explosionParticles, gameObject.transform.position, Quaternion.identity);
			GameController.explosionSoundQue = true;
			Destroy(transform.root.gameObject, 0.2f);
		}
	}
	void Smoke()
	{
		smokeFXTimer += Time.deltaTime;
		if(smokeFXTimer >= 1.0f)
		{
			Instantiate(smokeParticles, new Vector3(gameObject.transform.position.x,gameObject.transform.position.y+2,gameObject.transform.position.z), Quaternion.identity);
			smokeFXTimer = 0.0f;
		}
	}
}
