﻿using UnityEngine;
using System.Collections;

public class Turret : MonoBehaviour 
{
	public bool attack = false;
	public float rateOfFire = 0.5f; //In Seconds
	public float fireTimer = 0.0f;
	public GameObject projectile = null;
	GameObject[] targetsAvailable;
	public GameObject[] findTargets;
	GameObject closestTarget = null;
	public GameObject target = null;
	public float rotationSpeed = 1.0f;
	public float attackRange = 11.0f;
	public static Quaternion turretRotation = Quaternion.identity;
	public Quaternion lookAtTarget = Quaternion.identity;
	public GameObject explosionParticles = null;
	public GameObject smokeParticles = null;
	public int lifespan = 0;
	bool deathFX = false;
	int roundWhenPlaced = 0;
	float smokeFXTimer = 0.0f;
	
	void Start()
	{
		roundWhenPlaced = GameController.waveCounter;
	}

	void Update () 
	{
		if(roundWhenPlaced+lifespan == GameController.waveCounter)
			DestroySelf();
		if(roundWhenPlaced+lifespan-1 == GameController.waveCounter)
			Smoke();
		turretRotation = gameObject.transform.rotation;
		findTargets = GameObject.FindGameObjectsWithTag("enemy");
		FindTarget();
		if(findTargets.Length != 0)
		{
			if(findTargets == null || Vector3.Distance(gameObject.transform.position, closestTarget.transform.position) > attackRange)
			{
				attack = false;
				if(gameObject.transform.rotation != Quaternion.identity)
				{
					gameObject.transform.rotation = Quaternion.identity;
				}
			}
			else
			{
				gameObject.transform.LookAt(closestTarget.transform.position);
			}
			
			targetsAvailable = GameObject.FindGameObjectsWithTag("enemy"); //check to see if there is anything left to attack
			if(targetsAvailable.Length == 0)
			{
				attack = false;
			}
			
			if(attack == true && targetsAvailable.Length > 0)
			{
				fireTimer += Time.deltaTime;
				if(fireTimer >= rateOfFire)
				{
					fireTimer = 0.0f;
					Instantiate(projectile, gameObject.transform.position, turretRotation);
				}
			}
		}
		
	}
	void FindTarget()
	{
		
		foreach(GameObject targets in findTargets) //Locate closest target and set as target
		{
			if(closestTarget == null)
				closestTarget = targets;
			else if(Vector3.Distance(gameObject.transform.position, targets.transform.position) < Vector3.Distance(gameObject.transform.position, closestTarget.transform.position))
				closestTarget = targets;
		}
		target = closestTarget;
	}
	
	void OnTriggerStay(Collider other)
	{
		if(other.gameObject.tag == "enemy")
		{
			attack = true;	
		}
	}
	void OnTriggerExit(Collider other)
	{
		if(other.gameObject.tag == "turret_prj")
			attack = false;
	}
	void DestroySelf()
	{
	if(!deathFX)
	{
		deathFX = true;
		Instantiate(explosionParticles, gameObject.transform.position, Quaternion.identity);
		GameController.explosionSoundQue = true;
		Destroy(transform.root.gameObject, 0.2f);
	}
	}
	void Smoke()
	{
		smokeFXTimer += Time.deltaTime;
		if(smokeFXTimer >= 1.0f)
		{
			Instantiate(smokeParticles, gameObject.transform.position, Quaternion.identity);
			smokeFXTimer = 0.0f;
		}
	}
}
