﻿using UnityEngine;
using System.Collections;

public class TurretProjectile : MonoBehaviour 
{
	public float speed = 10.0f;
	float lifeTimer = 0.0f;
	public float lifeTime = 1.0f;
	bool calledDestroy = false;
	public GameObject explosionParticles = null;
	// Use this for initialization
	void Start () 
	{
	
	}
	
	// Update is called once per frame
	void Update () 
	{
		lifeTimer += Time.deltaTime;
		if(lifeTimer >= lifeTime)
			OnMissileDestroy();
		gameObject.transform.position += transform.forward * Time.deltaTime * speed;
	}
	
	void OnTriggerEnter(Collider other)
	{
		if(other.gameObject.tag == "enemy" && calledDestroy == false)
		{
			calledDestroy = true;
			other.GetComponent<Enemy>().health -= 25;
			OnMissileDestroy();
		}
		if(other.gameObject.tag == "terrain")
			OnMissileDestroy();
	}
	
	public void OnMissileDestroy()
	{
		GameController.turretPrjSoundQue = true;
		Instantiate(explosionParticles, gameObject.transform.position, Quaternion.identity);
		Destroy(gameObject);
	}
}
